char JSign[]="@(#)PMDMX0 V.0.80 by JUD at 2007/06/05";
char systemvarsion[]="0.96a";
char systemdate[]="2008/07/03";
/**********************************************************************/
/* PMDMX0.exe multimodule-P.M.D. for commandline by JUD at 2007/06/05 */
/**********************************************************************/
#include <windows.h>
#include <string.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdlib.h>
#include <LIMITS.H>
#include <io.h>
#include <process.h>
#include <errno.h>
#include <conio.h>
#include "PMDMX0.h"

/* globals */
HINSTANCE gx_pwdll[DN_MAX_LOADPMDWIN];
VARG a_arg;

/*--------------------------------------------------------------------*/
/* ERROR */
int sweepCritErr(int i1,char *cp="unknown function",int i2=0){
	int i;

	fprintf(stderr,"E[MX0] Critical ERROR, %d, %s, %d.\n",i1,cp,i2);
	for(i=0;i<DN_MAX_LOADPMDWIN;i++){
		FreeLibrary( gx_pwdll[i] );
	}
	exit(i1);
}
/*--------------------------------------------------------------------*/
/* ERRORMESSAGE */
int outErrorFromReturn(int ie,char *cp_in){

	char *cp_t;

	switch(ie){
		case ERR_OPEN_MUSIC_FILE:
			cp_t = DS_ERR_OPEN_MUSIC_FILE; break;
		case ERR_WRONG_MUSIC_FILE:
			cp_t = DS_ERR_WRONG_MUSIC_FILE; break;
		case ERR_OPEN_PPC_FILE:
			cp_t = DS_ERR_OPEN_PPC_FILE; break;
		case ERR_OPEN_P86_FILE:
			cp_t = DS_ERR_OPEN_P86_FILE; break;
		case ERR_OPEN_PPS_FILE:
			cp_t = DS_ERR_OPEN_PPS_FILE; break;
		case ERR_OPEN_PPZ1_FILE:
			cp_t = DS_ERR_OPEN_PPZ1_FILE; break;
		case ERR_OPEN_PPZ2_FILE:
			cp_t = DS_ERR_OPEN_PPZ2_FILE; break;
		case ERR_WRONG_PPC_FILE:
			cp_t = DS_ERR_WRONG_PPC_FILE; break;
		case ERR_WRONG_P86_FILE:
			cp_t = DS_ERR_WRONG_P86_FILE; break;
		case ERR_WRONG_PPS_FILE:
			cp_t = DS_ERR_WRONG_PPS_FILE; break;
		case ERR_WRONG_PPZ1_FILE:
			cp_t = DS_ERR_WRONG_PPZ1_FILE; break;
		case ERR_WRONG_PPZ2_FILE:
			cp_t = DS_ERR_WRONG_PPZ2_FILE; break;
		case ERR_OUT_OF_MEMORY:
			cp_t = DS_ERR_OUT_OF_MEMORY; break;
		case ERR_OTHER:
			cp_t = DS_ERR_OTHER; break;
		default:
			//printf("E[MX0] unknown error, return-code: %d.\n",ie);
			return(0);
	}

	fprintf(stderr,cp_t,cp_in);

	return(0);
}
/*--------------------------------------------------------------------*/
/* DLL 0:OK */
int copyPMDWINDLL(char *dname){
	char cs_dst[_MAX_PATH], cs_src[_MAX_PATH];
	char cs_cline[_MAX_PATH*2];
	struct _stat stf;
	int i_ret;

	memset( cs_dst, 0x00, _MAX_PATH );
	memset( cs_src, 0x00, _MAX_PATH );
	_snprintf(cs_src, _MAX_PATH-1, "%s%s", a_arg.exepath, DS_PMDWINDLLNAME);
	_snprintf(cs_dst, _MAX_PATH-1, "%s%s", a_arg.exepath, dname);

	/* łPMDWin.dllTBȂ-1 */
	i_ret = _stat( cs_src, &stf );
	if( i_ret < 0 ){ return(-1); }

	memset( cs_cline, 0x00, _MAX_PATH*2 );
	_snprintf(cs_cline, _MAX_PATH*2-1, "copy %s %s", cs_src, cs_dst);
	fprintf(stderr, "W[MX0] copy [%s] by [%s].\n", cs_dst, DS_PMDWINDLLNAME);
	i_ret = system( cs_cline );

	return(i_ret);
}
/*--------------------------------------------------------------------*/
/* DLL Initial */
int mx0LoadDLL(){
	int i;
	int i_ret, i_ver, i_ifver;
	bool b_ret;
	typedef bool (CALLBACK* XF_B_CP)(char *);
	XF_B_CP xf_b_cp;
	typedef int (CALLBACK* XF_I_CP)(char *);
	XF_I_CP xf_i_cp;
	typedef bool (CALLBACK* XF_B_CPP)(char **dirs);
	XF_B_CPP xf_b_cpp[DN_MAX_LOADPMDWIN];

	/* load dlls */
//printf("X[   ] modcount:%d\n",a_arg.modcount);
	for(i=0;i<a_arg.modcount;i++){

		gx_pwdll[i] = LoadLibrary( a_arg.dllname[i] );
		if( gx_pwdll[i] == NULL ){
			/* DLL(PMDWinXX.dll/XX=01-02)Ȃ */
			i_ret = copyPMDWINDLL( a_arg.dllname[i] );
			if( i_ret < 0 ){
				/* DLLɂs */
				fprintf(stderr,"E[MX0] Could not make [%s], Module:%d.\n",
					a_arg.dllname[i], i );
				sweepCritErr(-7,"mx0LoadDLL",i);
			}
			gx_pwdll[i] = LoadLibrary( a_arg.dllname[i] );
			if( i_ret < 0 ){
				/* DLLreloadɎs */
				fprintf(stderr,"E[MX0] Could not load [%s], Module:%d.\n",
					a_arg.dllname[i], i );
				sweepCritErr(-1,"mx0LoadDLL",i);
			}
		}
		//printf("D[MX0] load %s, Module:%d.\n", a_arg.dllname[i], i );

		/* IFo[W擾BgĂȂ */
		i_ver = (DFUNC(i,"getversion"))();
		i_ifver = (DFUNC(i,"getinterfaceversion"))();
		if( i_ver < 0 || i_ifver < 0 ){
			fprintf(stderr,"E[MX0] ERROR, could not got version.\n");
			sweepCritErr(-2,"mx0LoadDLL",i);
		}
		//printf("D[MX0]   version %d/%d.\n", i_ver, i_ifver);

		/* PMDWinXX.DLL */
		xf_b_cp = (XF_B_CP)GetProcAddress(gx_pwdll[i],DS_PWF_INIT);
		if( xf_b_cp == NULL ){ sweepCritErr(-3,"mx0LoadDLL",i); }
		b_ret = (xf_b_cp)(a_arg.wavd[i]);
		if( b_ret != true ){ sweepCritErr(-4,"mx0LoadDLL",i); }
		//printf("D[MX0]   initialize OK, wavdir:[%s], %d.\n",
		//	a_arg.wavd[i], b_ret); /* true:1 */

		/* PCMfBNgݒ{ MX0t@CŎw肳ĂȂΖӖ */
		xf_b_cpp[i] = (XF_B_CPP)GetProcAddress(gx_pwdll[i],DS_PWF_SETPXI);
		if( xf_b_cpp[i] == NULL ){ sweepCritErr(-9,"mx0LoadDLL",i); }
		b_ret = (xf_b_cpp[i])( (char **)(a_arg.pxipath) );
		if( b_ret == false ){ sweepCritErr(-8,"mx0LoadDLL",i); }

		/* tf[^[h */
		xf_i_cp = (XF_I_CP)GetProcAddress(gx_pwdll[i],DS_PWF_MLOAD);
		if( xf_i_cp == NULL ){ sweepCritErr(-5,"mx0LoadDLL",i); }
		i_ret = (xf_i_cp)(a_arg.mzname[i]);
		if( i_ret != 0 ){
			outErrorFromReturn(i_ret,a_arg.mzname[i]);
			sweepCritErr(-6,"mx0LoadDLL",i);
		}
		//printf("D[MX0]   read [%s] OK, %d.\n",a_arg.mzname[i],i_ret);

		/* ꎞԐ̎w yʓw̏ꍇ͎{Ȃ */
		if(a_arg.lightmode == D_OFF){
			a_arg.fPPSIP[i]=(XF_V_B)GetProcAddress(gx_pwdll[i],DS_PWF_SETPPSIP);
			if( a_arg.fPPSIP[i]==NULL ){ sweepCritErr(-10,"mx0LoadDLL",i); }
			a_arg.fP86IP[i]=(XF_V_B)GetProcAddress(gx_pwdll[i],DS_PWF_SETP86IP);
			if( a_arg.fP86IP[i]==NULL ){ sweepCritErr(-11,"mx0LoadDLL",i); }
			a_arg.fPPZIP[i]=(XF_V_B)GetProcAddress(gx_pwdll[i],DS_PWF_SETPPZIP);
			if( a_arg.fPPZIP[i]==NULL ){ sweepCritErr(-12,"mx0LoadDLL",i); }
		}
		/* PPSgp̎w */
		a_arg.fPPSUSE[i] = (XF_V_B)GetProcAddress(gx_pwdll[i],DS_PWF_SETPPSUSE);
		if( a_arg.fPPSUSE[i] == NULL ){ sweepCritErr(-13,"mx0LoadDLL",i); }

		/* Đ */
		(DFUNC(i,DS_PWF_MSTART))();
	}

	return(0);
}
/*--------------------------------------------------------------------*/
/* eLXgNX */
/* RXgN^:t@C̓ǂݍ݂ƑO */
READTEXT::READTEXT(char *fname){
	int i_infile, i_ret, i;
	struct _stat t_fs;
	char *cpc;

	buf=NULL; data=NULL;
	status=0; size=0; linecount=0;
	i_infile = _open( fname , _O_BINARY|_O_RDONLY );
	if( i_infile < 0 ){ status=-1; return; }
	i_ret = _fstat(i_infile, &t_fs);
	if( i_ret != 0 ){ status=-2; return; }
	size = t_fs.st_size;
	buf = (char *)malloc(size+2);
	memset(buf,0x00,size+2);
	i_ret = _read(i_infile,(buf+1),size);
	if( i_ret != size ){ status=-3; return; }
	_close( i_infile );
	data = (buf+1);
	curline = data;
	for(i=0,cpc=data;i<size;i++){ if(*cpc=='\n'){linecount++;} cpc++; }
}
/* fXgN^: */
READTEXT::~READTEXT(){
	if( buf != NULL ){
		free(buf);
	}
}
/* s ߂l͎擾J name/valueɂꂼꕶ */
/* 1Jڂ̏I[ƍs̏I[NULL㏑̕HȂi */
/* RXgN^œǂ񂾃f[^j󂵂Ȃiނߍėp͂łȂ */
int READTEXT::DIVIDETOKEN(){
	char *endp;

	for(;*curline=='\r'||*curline=='\n';curline++);
	/* eLXg̏I[łꍇzeroԂ */
	if( *curline=='\0' ){ name=NULL; value=NULL; return(0); }

	/* L׍sB */
	name = curline;
	curline = getNextLine(curline);

	for(value=name;(*value)!='\0'&&(*value)!='\n'&&(*value)!='\r';value++){
		if( *value == '\t' || *value == ' ' ){
			/* 2Jڂ݂ꍇ */
			*value = '\0';
			for(value++;(*value)=='\t'||(*value)==' ';value++);
			for(endp=value;(*endp)!='\0';endp++){
				if( *endp=='\r'||*endp=='\n' ){
					*endp = '\0';
					break;
				}
			}
			return(2);
		}
	}

	/* ̎_1JȂ */
	*value='\0'; return(1);
}
/* ֐ */
char *READTEXT::getNextLine( char *cp_in ){
	/* ̍s̐擪擾 ŏIsłꍇNULLŒ܂ */
	char *cp_cur;
	cp_cur = cp_in;
	do{
		cp_cur++;
	}while( *cp_cur != 0x00 && *(cp_cur-1) != '\n' );
	return(cp_cur);
}
/*--------------------------------------------------------------------*/
/* ARGNX */
VARG::VARG(){
	int i;
	char fname[_MAX_FNAME];
	char ext[_MAX_EXT];
	mxname = NULL;
	modcount = 0;
	pxicount = 0;
	rMixBuf = NULL;
	oftotal = 0;
	for(i=0;i<a_arg.modcount;i++){ a_arg.rModBuf[i] = NULL; }
	for(i=0;i<DN_DXBUFFERS;i++){ a_arg.directBuf[i] = NULL; }
	for(i=0;i<(DN_MAX_PXIDIRS+1);i++){
		memset(vpxipath[i],0x00,_MAX_PATH);
		pxipath[i] = NULL;
	}
	lightmode = D_OFF;
	if( lightmode == D_OFF ){
		maxunitsample = DN_MIXUNITSAMPLE;
	}else if( lightmode == D_ON ){
		maxunitsample = DN_MIXUNITSLIGHT;
	}
	outputlen = DN_DEF_OUTPUTLEN; /* default 2mins */
	quickstart = D_OFF;
	bufsize = maxunitsample * 2 * 2; /* steps x 16bits(2bytes) x 2ch */
	tps = DN_SAMPLERATE / maxunitsample;
	if( tps*maxunitsample != DN_SAMPLERATE ){
		sweepCritErr(-1,"VARG::VARG",tps);
	}
	for(i=0;i<DN_MAX_LOADPMDWIN;i++){
		memset(mzname[i],0x00,_MAX_PATH);
		memset(wavd[i],0x00,_MAX_PATH);
		_splitpath( DS_PMDWINDLLNAME, NULL, NULL, fname, ext );
		sprintf(dllname[i], "%s%02d%s",fname, i+1, ext);
	}
	memset(outwavename,'\0',_MAX_PATH);
	memset(exepath,'\0',_MAX_PATH);
	memset(datpath,'\0',_MAX_PATH);
	memset(playerpath,'\0',_MAX_PATH);
}
VARG::~VARG(){
}
/* MX0t@Cw肳ꂽꍇ */
int VARG::fMX(char *fname){
	READTEXT f_mx(fname);
	int i, j, k, i_ret;
	char sdrive[_MAX_DRIVE];
	char sdir[_MAX_DIR];
	char sfname[_MAX_FNAME];
	char ext[_MAX_EXT];

	modcount = 0;
	mxname = fname;
	_splitpath( fname, sdrive, sdir, sfname, ext );
	sprintf(outwavename,"%s%s%s%s",sdrive,sdir,sfname,DS_EXT_OUT);

	if( f_mx.status < 0 ){
		fprintf(stderr,"E[MX0] file read ERROR, [%s], code:[%d].\n",
			fname, f_mx.status);
		return( f_mx.status );
	}

	/* MX0t@C𑖍 */
	for(i=0;i<f_mx.linecount;i++){
		i_ret = f_mx.DIVIDETOKEN();
		if( i_ret == 0 ){ break; }
		if( f_mx.name == NULL || f_mx.name[0]==';' ){
			continue;
		}
		if( 0 == strcmp(f_mx.name,DS_DNAME_JUMPSTART) ||
			0 == _stricmp(f_mx.name,DS_DSNAME_JUMPSTART) ){
			j=atoi(f_mx.value);
			if( 0 < j ){ jumpstart = j; }
		}else if( 0 == strcmp(f_mx.name,DS_DNAME_RECORDLEN) ||
			0 == _stricmp(f_mx.name,DS_DSNAME_RECORDLEN) ){
			j=atoi(f_mx.value);
			if( 0 < j ){ outputlen = j; }
		}else if( 0 == strcmp(f_mx.name,DS_DNAME_QUICKSTART) ||
			0 == _stricmp(f_mx.name,DS_DSNAME_QUICKSTART) ){
			/* QSPMDMX0NɂȂ̂ŕsv? */
			quickstart = D_ON;
		}else if( 0 == strcmp(f_mx.name,DS_DNAME_PERFORMANCE) ||
			0 == _stricmp(f_mx.name,DS_DSNAME_PERFORMANCE) ){
			if( f_mx.value != NULL &&
				0==_stricmp(f_mx.value,DS_DVALUE_LIGHTMODE) ){
				switchLightMode();
			}
		}else if( 0 == strcmp(f_mx.name,DS_DNAME_PLAYERNAME) ||
			0 == _stricmp(f_mx.name,DS_DSNAME_PLAYERNAME) ){
			if( f_mx.value != NULL && strlen(f_mx.value) > 0 ){
				strcpy(playerpath,f_mx.value);
			}
		}else if( 0 == strcmp(f_mx.name,DS_DNAME_PXIPATH) ||
			0 == _stricmp(f_mx.name,DS_DSNAME_PXIPATH) ){
			if( pxicount>=DN_MAX_PXIDIRS ){
				fprintf(stderr,"W[MX0] too many PxI-Path, ignore [%s].\n",
					f_mx.value );
			}else{
				strncpy(vpxipath[pxicount], f_mx.value, _MAX_PATH-1);
				pxipath[pxicount] = vpxipath[pxicount];
				pxicount++;
			}
		}else if( f_mx.name[1] == 'M' ){
			/* default.mx0łtf[^w\check͍sȂ */
			j=atoi(f_mx.name)-1;
			if( 0 <= j && j < DN_MAX_LOADPMDWIN ){
				i_ret = fMZ(f_mx.value);
				if( i_ret < 0 ){ return(i_ret); }
			}
		}else if( f_mx.name[1] == 'W' ){
			/* mx0`̋Lq */
			j=atoi(f_mx.name)-1;
			if( 0 <= j && j < DN_MAX_LOADPMDWIN ){
				strncpy(wavd[j], f_mx.value, _MAX_PATH-1);
			}
		}else if( 0 == _strnicmp(f_mx.name,DS_DSNAME_RHYTHMDIR,
				strlen(DS_DSNAME_RHYTHMDIR)) ){
			/* mml`̋Lq modԍ̂ꏊႤ */
			j=atoi(&(f_mx.name[strlen(DS_DSNAME_RHYTHMDIR)]))-1;
			if( 0 <= j && j < DN_MAX_LOADPMDWIN ){
				strncpy(wavd[j], f_mx.value, _MAX_PATH-1);
			}else if( -1 == j ){
				/* ԍw肪ȂꍇASẴW[ɋʂ̐ݒ */
				for(k=0;k<DN_MAX_LOADPMDWIN;k++){
					strncpy(wavd[k], f_mx.value, _MAX_PATH-1);
				}
			}
		}else if( 0 == strcmp(f_mx.name,DS_DNAME_WAVEFILENAME) ||
			0 == _stricmp(f_mx.name,DS_DSNAME_WAVEFILENAME) ){
			strncpy(outwavename, f_mx.value, _MAX_PATH-1);
		}
	}

	return(0);
}
/* MZt@Cw肳ꂽꍇ */
int VARG::fMZ(char *fname){
	int i_ret;
	struct _stat fst;
	if( modcount >= DN_MAX_LOADPMDWIN ){
		fprintf(stderr,"W[MX0] too many MZ-Files, ignore [%s].\n",fname);
		return(1);
	}
	i_ret = _stat( fname, &fst );
	if( i_ret < 0 ){
		fprintf(stderr,"E[MX0] not found MZ-File, [%s].\n",fname);
		return(i_ret);
	}
	strncpy(mzname[modcount], fname, _MAX_PATH-1);
//printf("D[MX0] mod:%d %s, find MZI.\n",modcount,mzname[modcount]);
	modcount++;
	return(0);
}
/* R}hC */
int VARG::loadArg(int argc,char **argv){

	int i, j;
	int i_ret;
	char sdrive[_MAX_FNAME];
	char sdir[_MAX_EXT];
	char sfname[_MAX_FNAME];
	char sext[_MAX_EXT];
	char cs_myName[_MAX_PATH];
	char cs_exeName[_MAX_PATH];
	struct _stat stf;

	if( argc<2 ){ return(-1); }

	/* g̋NpX */
	_splitpath( argv[0], sdrive, sdir, sfname, sext );
	if( 0==strlen(sext) ){
		_makepath( cs_exeName, sdrive, sdir, sfname, ".exe" );
	}else{
		strcpy( cs_exeName, argv[0] );
	}
	/* t@Cč\z */
	_splitpath( cs_exeName, sdrive, sdir, sfname, sext );
	if( 0==strlen(sdrive) && 0==strlen(sdir) ){
		/* tpXwł͂Ȃ̂Ŋϐpath猟 */
		_searchenv( cs_exeName, "path", exepath );
		if( exepath == NULL || strlen(exepath) == 0 ){
			strcpy(sdir,".\\");
		}else{
			_splitpath( exepath, sdrive, sdir, sfname, sext );
		}
	}
	_makepath( exepath, sdrive, sdir, NULL, NULL );
	_fullpath( exepath, exepath, _MAX_PATH );

	/* PMDMX0.mx0/default.mx0ΐɓǂł */
	sprintf(defMX0path,"%s%s",exepath,DS_DEFAULTMX0_PMDMX0);
	if( 0 == _stat( defMX0path, &stf )){
		fMX(defMX0path);
	}else{
		/* PMDMX0.mx0݂Ȃꍇ̂default.mx0ǂ */
		sprintf(defMX0path,"%s%s",exepath,DS_DEFAULTMX0_DEF);
		if( 0 == _stat( defMX0path, &stf )){
			fMX(defMX0path);
		}else{
			memset(defMX0path,0x00,_MAX_PATH);
		}
	}

	for(i=1;i<argc;i++){
		_splitpath( argv[i], NULL, NULL, sfname, sext );
		if( 0 == _stricmp(DS_EXT_MX0,sext) ){
			i_ret = fMX(argv[i]);
		}else if( 0 == _stricmp(DS_EXT_MZ,sext) ){
			i_ret = fMZ(argv[i]);
		}else{
			fprintf(stderr,"E[MX0] unknown File-Type [%s].\n",argv[i]);
			return(-1);
		}
		if( i_ret < 0 ){ return( i_ret ); }
	}

	return(0);
}
/* yʓw */
int VARG::switchLightMode(){
	lightmode = D_ON;
	/* obt@TCY6{ɊgA]px1/6ɒቺ */
	maxunitsample = DN_MIXUNITSLIGHT;
	bufsize = maxunitsample * 2 * 2; /* steps x 16bits(2bytes) x 2ch */
	tps = DN_SAMPLERATE / maxunitsample;
	if( tps*maxunitsample != DN_SAMPLERATE ){
		sweepCritErr(-1,"VARG::switchLightMode",tps);
	}
	/* oߎԕ\sȂ(ʂ̏ꏊa_arg.lightmodeĂ) */
	return(0);
}
/* ݒ荀ڈꗗ\ */
int VARG::viewSettings(){
	int i;
	fprintf(stderr,"s[MX0] ----------------------------------------------------------------------\n");
	if( mxname != NULL ){
		if( lightmode == D_OFF ){
			fprintf(stderr,"s[MX0] Performance      : 60 transfer/sec\n");
		}else{
			fprintf(stderr,"s[MX0] Performance      : Light-Mode, 10 transfer/sec\n");
		}
		fprintf(stderr,"s[MX0] MX Filename      : %s\n",mxname);
		if( 0 < strlen(defMX0path) ){
			fprintf(stderr,"s[MX0] Default Settings : %s\n",defMX0path);
		}
		fprintf(stderr,"s[MX0] Player Filename  : %s\n",playerpath);
		if( 0 != strcmp(playerpath,DS_DVALUE_INTERNALPLAYER) ){
			fprintf(stderr,"s[MX0] Output Filename  : %s\n",outwavename);
		}
		fprintf(stderr,"s[MX0] Output Length    : %d seconds.\n",outputlen);
		if( jumpstart != 0 ){
			fprintf(stderr,"s[MX0] Skip Length      : %d seconds.\n",jumpstart);
		}
		//fprintf(stderr,"s[MX0] PxI-Files paths  : %d\n",pxicount);
		for(i=0;i<pxicount;i++){
			fprintf(stderr,"s[MX0] PxI-Path(%2d)     : %s\n",
				i+1, pxipath[i]);
		}
	}
	for(i=0;i<modcount;i++){
		//fprintf(stderr,"s[MX0] Module(%d)\n",i+1);
		//fprintf(stderr,"s[MX0] MZ Filename(%d)   : %s\n",i+1,mzname[i]);
		fprintf(stderr,"s[MX0] RhthmPCM Path(%d) : %s\n",i+1,wavd[i]);
	}
	fprintf(stderr,"s[MX0] ------------------ ------------ ------------ ------------ ------------\n");

	return(0);
}
/*--------------------------------------------------------------------*/
/* t@Cւ̍Đ-MIXNX */
VMIX::VMIX(){
	int i;
	bufsize = a_arg.maxunitsample * 4;
	mixunits = a_arg.maxunitsample;
	mixsteps = mixunits * 2; /* x 2ch */
	mixbuf = NULL;
	outbuf = NULL;
	for(i=0;i<a_arg.modcount;i++){
		modbuf[i] = NULL;
		xf_v_sp_i[i] = (XF_V_SP_I)GetProcAddress(gx_pwdll[i],DS_PWF_GETPCM);
		if( xf_v_sp_i[i] == NULL ){ sweepCritErr(-1,"VMIX-init",i); }
	}
}
VMIX::~VMIX(){
	int i;
	if(mixbuf!=NULL){
		free(mixbuf);
	}
	if(outbuf!=NULL){
		free(mixbuf);
	}
	for(i=0;i<DN_MAX_LOADPMDWIN;i++){
		if(mixbuf!=NULL){
			free(modbuf[i]);
		}
	}
}
int VMIX::mixStart(){
	int i;
	mixbuf = (long *)malloc(bufsize * 2);
	outbuf = (short *)malloc(bufsize);
	for(i=0;i<a_arg.modcount;i++){
		modbuf[i] = (short *)malloc(bufsize);
	}
	return(0);
}
int VMIX::mixPlay(){

	int i, j;
	int i_ret;
	short *sp_cur;
	long *lp_cur;

	for(i=0;i<a_arg.modcount;i++){
		(xf_v_sp_i[i])( modbuf[i], mixunits); /* call getpcmdata */
	}
	memset(mixbuf,0x00,bufsize*2);
	memset(outbuf,0x00,bufsize);
	for(i=0;i<a_arg.modcount;i++){ /* Mix */
		sp_cur = modbuf[i];
		lp_cur = mixbuf;
		for(j=0;j<mixsteps;j++){
			*lp_cur += (long)(*sp_cur);
			lp_cur++;
			sp_cur++;
		}
	}
	sp_cur = outbuf;
	lp_cur = mixbuf;
	for(j=0;j<mixsteps;j++){
		if( (*lp_cur) > SHRT_MAX ){ *lp_cur=SHRT_MAX; }
		if( (*lp_cur) < SHRT_MIN ){ *lp_cur=SHRT_MIN; }
		*sp_cur = (short)(*lp_cur);
		lp_cur++;
		sp_cur++;
	}

	return(0);
}
/*--------------------------------------------------------------------*/
/* t@Cւ̍Đ-OUTPCMNX */
OUTPCM::OUTPCM(char *outname,int outputsecs){
	T_COMBINEWAVEH t_h;
	i_outfile = _open(outname,
		_O_CREAT|_O_TRUNC|_O_BINARY|_O_WRONLY, _S_IREAD | _S_IWRITE);
	memcpy(t_h.c_ftype,"RIFF",4);
	memcpy(t_h.c_rtype,"WAVE",4);
	memcpy(t_h.c_fctype,"fmt ",4);
	t_h.i_fcsize = 16;
	t_h.fID = 1;
	t_h.ch = 2;
	t_h.hz = DN_SAMPLERATE;
	t_h.bitrate = 16;
	t_h.blocksize = (t_h.bitrate/8) * t_h.ch;
	t_h.bps = t_h.hz * t_h.blocksize;
	memcpy(t_h.c_dctype,"data",4);
	t_h.i_dcsize = outputsecs * DN_SAMPLERATE * 4;
	t_h.i_size = t_h.i_dcsize + sizeof(T_COMBINEWAVEH) - 8;
	_write(i_outfile,&t_h,sizeof(T_COMBINEWAVEH));
}
OUTPCM::~OUTPCM(){
	close(i_outfile);
}
int OUTPCM::outWave(short *sp, int steps){
	_write(i_outfile,sp,steps*4);
	return(0);
}
/*--------------------------------------------------------------------*/
/* A^CĐ-~LVO */
int fmxMixing(int side){

	int i, j;
	int i_ret;
	short *sp_cur;
	long *lp_cur;
	int totalsamples;
	int ofcount;

	ofcount=0;
	for(i=0;i<a_arg.modcount;i++){
		(a_arg.fGetPCM[i])( a_arg.rModBuf[i], a_arg.maxunitsample );
	}
	memset(a_arg.rMixBuf,0x00,a_arg.bufsize*2);
	memset(a_arg.directBuf[side],0x00,a_arg.bufsize);
	totalsamples = a_arg.maxunitsample * 2; /* 2ch */
	for(i=0;i<a_arg.modcount;i++){ /* Mix */
		sp_cur = a_arg.rModBuf[i];
		lp_cur = a_arg.rMixBuf;
		for(j=0;j<totalsamples;j++){
			*lp_cur += (long)(*sp_cur);
			lp_cur++;
			sp_cur++;
		}
	}
	sp_cur = a_arg.directBuf[side];
	lp_cur = a_arg.rMixBuf;
	for(j=0;j<totalsamples;j++){
		if( (*lp_cur) > SHRT_MAX ){ *lp_cur=SHRT_MAX; ofcount++; }
		if( (*lp_cur) < SHRT_MIN ){ *lp_cur=SHRT_MIN; ofcount++; }
		*sp_cur = (short)(*lp_cur);
		lp_cur++;
		sp_cur++;
	}

	return(ofcount);
}
/*--------------------------------------------------------------------*/
/* A^CĐ-o */
int fmxPlayMix(int side){

	int i, ofcount;
	MMRESULT v_result1;
static WAVEHDR *tp_Data[DN_DXBUFFERS]={NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL};

//printf("D[fmxPlayMix] mix, use [%d] side-buffer.\n",side);

	if( a_arg.hWave == NULL ){
//printf("D[fmxPlayMix] end PLAY.\n");
		return(0);
	}

	if( tp_Data[0] == NULL ){
		/* obt@̏ݒ */
		for(i=0;i<DN_DXBUFFERS;i++){
//printf("D[fmxPlayMix] init/1.\n");
			tp_Data[i] = (WAVEHDR *)malloc(sizeof(WAVEHDR));
			memset(tp_Data[i],0x00,sizeof(WAVEHDR));
			tp_Data[i]->lpData = (LPSTR)(a_arg.directBuf[i]);
			tp_Data[i]->dwBufferLength  = a_arg.bufsize;
			tp_Data[i]->dwBytesRecorded = 0;
			tp_Data[i]->dwUser = 0;
			tp_Data[i]->dwFlags = 0;
			tp_Data[i]->dwLoops = 1;
			tp_Data[i]->lpNext = NULL;
			tp_Data[i]->reserved = 0;
		}
	}

	if( side < 0 ){
//printf("D[fmxPlayMix] init/2.\n");
		for(i=0;i<DN_DXBUFFERS;i++){
			/* prepare̓obt@̐JԂ */
			tp_Data[i]->lpData = (LPSTR)(a_arg.directBuf[i]);
			v_result1 = waveOutPrepareHeader(
				a_arg.hWave, tp_Data[i], sizeof(WAVEHDR));
//printf("D[fmxPlayMix] %d / waveOutPrepareHeader[%d], %d\n",i,v_result1,tp_Data[i]->lpData);
		}
		return(0);
	}

	/* play-mix */
	ofcount = fmxMixing(side);

	v_result1 = waveOutWrite(a_arg.hWave, tp_Data[side], sizeof(WAVEHDR));
//printf("D[fmxPlayMix] %d / waveOutWrite, %08X/%08X/%08X\n",v_result1,a_arg.hWave, tp_Data[side],tp_Data[side]->lpData);

	return(ofcount);
}
/*--------------------------------------------------------------------*/
/* A^CĐ-XLbv A^CłȂĂg */
int fmxPlaySkip(int jseconds){
	int i, j;
	typedef void (CALLBACK* XF_V_I)(int);
	XF_V_I xf_v_i[DN_MAX_LOADPMDWIN];

//printf("D[fmxPlaySkip] skip %d seconds.\n",jseconds);

	if( jseconds > 0 ){
		for(i=0;i<a_arg.modcount;i++){
			xf_v_i[i] = (XF_V_I)GetProcAddress(gx_pwdll[i],DS_PWF_SETPOS);
			if( xf_v_i[i] == NULL ){ sweepCritErr(-1,"playMix2File",i); }
			(xf_v_i[i])(jseconds*1000); /* SETPOS͒PʂmsecȂ̂Œ */
		}
	}
	/* setpos͌ʂ擾łȂdlȂ̂łǂĂI */
	return(0);
}
/*--------------------------------------------------------------------*/
/* A^CĐ-CALLBACK function */
void CALLBACK waveOutProc( HWAVEOUT hwo, UINT uMsg,
	DWORD dwInstance, DWORD dwParam1, DWORD dwParam2){

static int ofcount, ofpct, ofremain;
static int ofmax=0;
static int readybuffers=0; /* pӂłobt@ ݎgpĂȂ */
static int nextbuffer=-1; /* ɍXVׂobt@TChԍ */

static int tcFrames;
static int tcSeconds;
static int tcMinutes;

static char cs_ofview[64]={' ',0,0,0,0x25,0x20,0x6f,0x76,0x65,0x72,0x66,0x6c,0x6f,0x77,8,8,8,8,8,8,8,8,8,8,8,8,8,8,0};
static char cs_ofzero[64]={' ',' ',' ',' ',' ',8,8,8,8,8,0};
static char cs_clock1[32]={8,8,0,0,0};
static char cs_clock2[32]={8,8,8,8,8,0,0,'.','0','0',0};
static char cs_clock3[32]={8,8,8,8,8,8,8,8,8,
	' ',' ','0',':','0','0','.','0','0',0};

//printf("D[CB] - %d / %d,%d,%d\n",uMsg,dwInstance,dwParam1,dwParam2);


	switch( uMsg ){
		case MM_WOM_OPEN:
			nextbuffer=0;
			tcFrames=0;
			tcSeconds=0;
			tcMinutes=0;
			readybuffers++;
//printf("/[CB] READY-BUFFERS(remain:%d).\n",readybuffers);
			fmxPlaySkip(a_arg.jumpstart);
			if( a_arg.jumpstart > 0 ){
				tcSeconds = a_arg.jumpstart%60;
				tcMinutes = a_arg.jumpstart/60;
			}
			break;
		case MM_WOM_CLOSE:
			readybuffers--;
//printf("/[CB] CLOSE-BUFFERS(remain:%d).\n",readybuffers);
			break;
		case MM_WOM_DONE:
//printf("/[CB] DONE(%d).\n",nextbuffer);
			ofcount = fmxPlayMix(nextbuffer);
			nextbuffer++;
			if( nextbuffer >= DN_DXBUFFERS ){ nextbuffer=0; }
			/* oߎԕ\ yʓ쎞w͍sȂ */
			if( a_arg.lightmode == D_OFF ){
				tcFrames++;
				if( tcFrames >= a_arg.tps ){
					tcFrames = 0;
					tcSeconds++;
					if( tcSeconds >= 60 ){
						tcSeconds = 0;
						tcMinutes++;
						if( (tcMinutes%10) == 0 ){
							cs_clock3[10] = 0x30 + (tcMinutes%100)/10;
							if( (tcMinutes%100) == 0 ){
								cs_clock3[9] = 0x30 + tcMinutes/100;
							}
						}
						cs_clock3[11] = 0x30 + (tcMinutes%10);
						_cputs(cs_clock3);
					}else{
						cs_clock2[5]=0x30+tcSeconds/10;
						cs_clock2[6]=0x30+tcSeconds%10;
						_cputs(cs_clock2);
					}
				}else{
					cs_clock1[2]=0x30+tcFrames/10;
					cs_clock1[3]=0x30+tcFrames%10;
					_cputs(cs_clock1);
				}
				/* overflow\ */
				if( ofcount > 0 ){
					a_arg.oftotal += ofcount;
					if( ofmax < ofcount || ofremain < 0 ){
						ofpct = (ofcount*100+a_arg.maxunitsample-100)
							/ (a_arg.maxunitsample);
						cs_ofview[1]=0x30+(ofpct)/100;
						cs_ofview[2]=0x30+(ofpct%100)/10;
						if( cs_ofview[1]=='0' ){ cs_ofview[1]=' ';
							if( cs_ofview[2]=='0' ){ cs_ofview[2]=' ';}}
						cs_ofview[3]=0x30+(ofpct%10);
						_cputs(cs_ofview);
						ofmax = ofcount;
						ofremain = DN_OVERFLOWREFRESH;
					}else{
						ofremain--;
					}
				}else{
					if( ofmax > 0 && ofremain < 0 ){
						_cputs(cs_ofzero);
						ofmax=0;
					}else{
						ofremain--;
					}
				}
			}
			break;
		default:
			/* Ȃ */
			break;
	}

	return;
}
/*--------------------------------------------------------------------*/
/* ԐL[͑҂ */
/* P:milliseconds ߒl:L[(ASCII)/Ԑ؂(0) 𑜓x:100msec*/
#define DN_RESO_KEYPRESS 100
int waitKeyPressWithTimeout(long toms){
	long l,j;
	for(l=0;l<toms;l+=DN_RESO_KEYPRESS){
		if( !_kbhit() ){ Sleep(100); continue; }
		j=_getch();
		switch(j){
			case 'Q':
			case 'q':
			case 'W':
			case 'w':
				return(j);
		}
	}
	return(0);
}
/*--------------------------------------------------------------------*/
/* [Nf[^擾/\ VWORKNX */
VWORK::VWORK(){
	int i;
	for(i=0;i<a_arg.modcount;i++){
		f_gwo[i] = (XF_T1_V)GetProcAddress(gx_pwdll[i],DS_PWF_GETWORKOPEN);
		if( f_gwo[i] == NULL ){ sweepCritErr(-1,"VWORK::VWORK",i); }
		f_gwp[i] = (XF_T2_I)GetProcAddress(gx_pwdll[i],DS_PWF_GETWORKPART);
		if( f_gwp[i] == NULL ){ sweepCritErr(-2,"VWORK::VWORK",i); }
		f_gfm[i] = (XF_CP_CP)GetProcAddress(gx_pwdll[i],DS_PWF_GETFNAMEMZ);
		if( f_gfm[i] == NULL ){ sweepCritErr(-3,"VWORK::VWORK",i); }
		f_gfp[i] = (XF_CP_CP)GetProcAddress(gx_pwdll[i],DS_PWF_GETFNAMEPCM);
		if( f_gfp[i] == NULL ){ sweepCritErr(-4,"VWORK::VWORK",i); }
		f_gfs[i] = (XF_CP_CP)GetProcAddress(gx_pwdll[i],DS_PWF_GETFNAMEPPS);
		if( f_gfs[i] == NULL ){ sweepCritErr(-5,"VWORK::VWORK",i); }
		f_gfz[i] = (XF_CP_CP_I)GetProcAddress(gx_pwdll[i],DS_PWF_GETFNAMEPPZ);
		if( f_gfz[i] == NULL ){ sweepCritErr(-6,"VWORK::VWORK",i); }
	}
	sprintf(cs_lvh ,"s[MX0] VolumeDownValues :");/* 𑵂 */
	sprintf(cs_lvf ,"s[MX0] VolumeDown   FM  :");
	sprintf(cs_lvs ,"s[MX0]              SSG :");
	sprintf(cs_lvp ,"s[MX0]              PCM :");
	sprintf(cs_lvz ,"s[MX0]              PPZ :");
	sprintf(cs_fnm ,"s[MX0] Filenames    MZ  :");
	sprintf(cs_fnp ,"s[MX0]         P86/PPC  :");
	sprintf(cs_fns ,"s[MX0]             PPS  :");
	sprintf(cs_fnz1,"s[MX0]             PPZ1 :");
	sprintf(cs_fnz2,"s[MX0]             PPZ2 :");
	titlelen = strlen(cs_lvh);
}
VWORK::~VWORK(){
}
char *VWORK::getLocalNameByFullName(char *fullname,int maxlen){
	char sdrive[_MAX_FNAME],sdir[_MAX_EXT],sfname[_MAX_FNAME],sext[_MAX_EXT];
	char snameext[_MAX_PATH];
	int isf, ist, ifnlen;
static char lnameext[_MAX_PATH];
	_splitpath( fullname, sdrive, sdir, sfname, sext );
	_makepath( snameext, NULL, NULL, sfname, sext );
	if( maxlen > 0 ){
		/* Œ蒷wȂEl */
		ifnlen = strlen(snameext);
		if( ifnlen < maxlen ){
			isf=ifnlen; ist=maxlen-ifnlen;
		}else{
			isf=maxlen; ist=0;
		}
		memset(lnameext,' ',maxlen);
		memcpy(&(lnameext[ist]),snameext,isf);
		if( ifnlen == 0 ){ lnameext[maxlen-1]='-'; } /* 󗓂j~ */
		lnameext[maxlen] = '\0';
	}else{
		strcpy(lnameext,snameext);
	}
	return(lnameext);
}
int VWORK::viewWork(int level){

	int i;
	char *cp_ret;
	char cs_name[1024];

	memset(cs_name,0x00,1024);
	for(i=0;i<a_arg.modcount;i++){
		cp_ret = (f_gfm[i])(cs_name);
		cp_ret = getLocalNameByFullName(cp_ret,12);
		sprintf(&(cs_fnm[strlen(cs_fnm)])," %s",cp_ret);
		cp_ret = (f_gfp[i])(cs_name);
		cp_ret = getLocalNameByFullName(cp_ret,12);
		sprintf(&(cs_fnp[strlen(cs_fnp)])," %s",cp_ret);
		cp_ret = (f_gfs[i])(cs_name);
		cp_ret = getLocalNameByFullName(cp_ret,12);
		sprintf(&(cs_fns[strlen(cs_fns)])," %s",cp_ret);
		cp_ret = (f_gfz[i])(cs_name,0);
		cp_ret = getLocalNameByFullName(cp_ret,12);
		sprintf(&(cs_fnz1[strlen(cs_fnz1)])," %s",cp_ret);
		cp_ret = (f_gfz[i])(cs_name,1);
		cp_ret = getLocalNameByFullName(cp_ret,12);
		sprintf(&(cs_fnz2[strlen(cs_fnz2)])," %s",cp_ret);
		tps_wo[i] = (f_gwo[i])();
		sprintf(&(cs_lvh[strlen(cs_lvh)])," M.%10d",i+1);
		sprintf(&(cs_lvf[strlen(cs_lvf)])," %12d",tps_wo[i]->fm_voldown);
		sprintf(&(cs_lvs[strlen(cs_lvs)])," %12d",tps_wo[i]->ssg_voldown);
		sprintf(&(cs_lvp[strlen(cs_lvp)])," %12d",tps_wo[i]->pcm_voldown);
		sprintf(&(cs_lvz[strlen(cs_lvz)])," %12d",tps_wo[i]->rhythm_voldown);
	}
	fprintf(stderr,"%s\n",cs_fnm);
	fprintf(stderr,"%s\n",cs_fnp);
	fprintf(stderr,"%s\n",cs_fns);
	fprintf(stderr,"%s\n",cs_fnz1);
	fprintf(stderr,"%s\n",cs_fnz2);
	//fprintf(stderr,"%s\n",cs_lvh);
	fprintf(stderr,"%s\n",cs_lvf);
	fprintf(stderr,"%s\n",cs_lvs);
	fprintf(stderr,"%s\n",cs_lvp);
	fprintf(stderr,"%s\n",cs_lvz);

	cs_fnm[titlelen] = '\0';	cs_fnp[titlelen] = '\0';
	cs_fns[titlelen] = '\0';	cs_fnz1[titlelen] = '\0';
	cs_fnz2[titlelen] = '\0';	cs_lvh[titlelen] = '\0';
	cs_lvf[titlelen] = '\0';	cs_lvs[titlelen] = '\0';
	cs_lvp[titlelen] = '\0';	cs_lvz[titlelen] = '\0';

	fprintf(stderr,"s[MX0] ------------------ ------------ ------------ ------------ ------------\n");

	return(0);
}
/*--------------------------------------------------------------------*/
/* A^CĐ */
int playMix2DX(int outseconds){

	int i;
	int key;

	HWAVEOUT hWave;
	MMRESULT v_result1;
	WAVEFORMATEX t_Format;

static int rewinded = D_OFF;

	VWORK a_vwk;

//printf("D[2DX] Start.\n");

	/* init */
	for(i=0;i<DN_DXBUFFERS;i++){
		if( a_arg.directBuf[i] == NULL ){
			a_arg.directBuf[i] = (short *)malloc(a_arg.bufsize);
		}
		memset(a_arg.directBuf[i],0x00,a_arg.bufsize);
	}
	/* setting */
	t_Format.wFormatTag = WAVE_FORMAT_PCM;
	t_Format.nChannels = 2;
	t_Format.nSamplesPerSec = DN_SAMPLERATE;
	t_Format.nAvgBytesPerSec = DN_SAMPLERATE*4;
	t_Format.nBlockAlign = 4;
	t_Format.wBitsPerSample = 16;
	t_Format.cbSize = 0;

	/* dll, buffers */
	if( a_arg.rMixBuf == NULL ){
		a_arg.rMixBuf = (long *)malloc(a_arg.bufsize * 2);
	}
	for(i=0;i<a_arg.modcount;i++){
		if( a_arg.rModBuf[i] == NULL ){
			a_arg.rModBuf[i] = (short *)malloc(a_arg.bufsize);
		}
		a_arg.fGetPCM[i] = (XF_V_SP_I)GetProcAddress(gx_pwdll[i],DS_PWF_GETPCM);
		if( a_arg.fGetPCM[i] == NULL ){ sweepCritErr(-1,"playMix2DX",i); }
	}

	/* open device */
	v_result1 = waveOutOpen(
		&hWave, WAVE_MAPPER,
		&t_Format,(DWORD)waveOutProc, 0, CALLBACK_FUNCTION);
//printf("D[2DX] %d / waveOutOpen, %d\n",v_result1,hWave);
	a_arg.hWave = hWave;


	/* ̍Đ sobt@SĎg */
	fmxPlayMix(-1);

	if( rewinded == D_OFF ){
		a_vwk.viewWork(0); /* ŏ̍ĐsȂVolumeDownXVȂ */
		fprintf(stderr,"-[MX0] press <Q> to terminate, <W> to rewind.\n");
	}
	/* oߎԕ\ yʓw莞͕\Ȃ */
	if( a_arg.lightmode == D_OFF ){
		fprintf(stderr,"-[MX0] Playback,%3d:%02d.%02d",
			a_arg.jumpstart/60,a_arg.jumpstart%60,0);
	}else{
		fprintf(stdout,"-[MX0] Playback...\n");
	}
	for(i=0;i<DN_DXBUFFERS;i++){
		fmxPlayMix(i);
	}

	/* waiting */
//printf("D[2DX] Run, Sleep %d seconds.\n",outseconds);
	key = waitKeyPressWithTimeout( (long)(outseconds*1000-200));
//printf("D[2DX] end Sleep\n");
	a_arg.hWave=NULL; /*test*/
	Sleep(200);

	/* oߎԕ\ yʓw莞͕\Ȃ */
	if( a_arg.lightmode == D_OFF ){
		fprintf(stderr,"\n");
	}
	/* L[͊Ď */
	switch(key){
		case 'q':
		case 'Q':
			fprintf(stderr,"-[MX0] terminated Playback.\n");
			v_result1 = waveOutReset(hWave);
			v_result1 = waveOutClose(hWave);
			return(D_CONSOLE_TERMINATE);
		case 'w':
		case 'W':
			fprintf(stderr,"-[MX0] rewind.\n");
			v_result1 = waveOutReset(hWave);
			v_result1 = waveOutClose(hWave);
			rewinded = D_ON;
			return(D_CONSOLE_REWIND);
	}

	/* finish */
	v_result1 = waveOutReset(hWave);
//printf("D[2DX] %d / waveOutReset\n",v_result1);
	v_result1 = waveOutClose(hWave); 
//printf("D[2DX] %d / waveOutClose\n",v_result1);

	return(0);
}
/*--------------------------------------------------------------------*/
/* t@Cւ̍Đ */
int playMix2File(){

	VMIX xPlay;
	OUTPCM xOutPCM(a_arg.outwavename,a_arg.outputlen);
	int i, j;

	xPlay.mixStart();

//printf("D[   ] output [%s] %d seconds, jump %d seconds.\n",
//a_arg.outwavename,a_arg.outputlen,a_arg.jumpstart);

	/* XLbv ʂ͎擾łȂPMDWin.dll̎dl */
	fmxPlaySkip(a_arg.jumpstart);

	/* o͐:t@C */
	for(i=0;i<a_arg.outputlen;i++){
		for(j=0;j<a_arg.tps;j++){
			xPlay.mixPlay();
			xOutPCM.outWave(xPlay.outbuf,xPlay.mixunits);
		}
	}

	return(0);
}
/*--------------------------------------------------------------------*/
/* EXECUTE-MAIN */
int main(int argc,char **argv,char **envp){
	int i_ret;
	int i;
	char cs_cline[_MAX_PATH];

	/* args/setting */
	if( argc<2 ){
		fprintf(stderr,"\nPMDMX0.exe P.M.D.MultiplieX Ver.%s by JUD/JUDSTYLE/JUDSYSTEM.\n",systemvarsion);
		fprintf(stderr,"  usage(1) : PMDMX0.exe <filename.mx0>\n");
		fprintf(stderr,"  usage(2) : PMDMX0.exe <filename.mz> [filename.mz]\n");
		fprintf(stderr,"\n    -> http://judstyle.jp/wiki/PMDMX0\n");

		exit(1);
	}
	i_ret = a_arg.loadArg(argc,argv);
	if( i_ret < 0 ){
		exit(i_ret);
	}
	fprintf(stderr,"-[MX0] Start PMDMX0.exe, P.M.D.MultiplieX Ver.%s\n",
		systemvarsion);
	a_arg.viewSettings(); /* ݒ\ */
	i_ret = mx0LoadDLL(); /* DLL[h/ */

	/* Đ */
	if( 0 == strcmp(a_arg.playerpath,DS_DVALUE_INTERNALPLAYER) ){
		do{
			i_ret = playMix2DX(a_arg.outputlen);
		}while(i_ret == D_CONSOLE_REWIND);
	}else{
		i_ret = playMix2File();
	}

	if( a_arg.oftotal > 0 ){
		fprintf(stderr,"W[MX0] found OVERFLOW, %d times.\n",a_arg.oftotal);
	}

	/* unload dlls */
	for(i=0;i<a_arg.modcount;i++){
		(DFUNC(i,"music_stop"))();
		FreeLibrary( gx_pwdll[i] );
	}
	fprintf(stderr,"-[MX0] Finish PMDMX0.exe.\n");

	/* wavt@Cȏ͎Đ */
	if( a_arg.quickstart == D_ON ){
		memset(cs_cline,'\0',_MAX_PATH);
		if( 0 < strlen(a_arg.playerpath) ){
			if( 0 == strcmp(a_arg.playerpath,DS_DVALUE_INTERNALPLAYER) ){
				/* A^CĐς݂Ȃ̂łł͉Ȃ */
			}else{
				sprintf(cs_cline, "%s %s\n",
					a_arg.playerpath, a_arg.outwavename );
				system( cs_cline );
			}
		}else{
			strcpy( cs_cline, a_arg.outwavename );
			system( cs_cline );
		}
	}

	return(0);
}
/*--------------------------------------------------------------------*/
/* V0.95 */
/*   EDLLȂꍇ̓Rs[:-) */
/*     exeƓfBNgPMDWin.dllΕ쐬 */
/*   EP?It@C̓ǂݍ݃pX */
/*     MX0PPǉ */
/*   Et@CpXtŎw肵ȂƓȂ */
/*     MCMX1.exeőΏ IɃtpXw肷 */
/*   EMC.exeOt@Cl[ɑΉĂȂ */
/*     MC.exe1.24őΉ */
/* V0.952 */
/*   EMX0PWɂwavĐAvw\ */
/*     MC.exe1.25Ƃ킹đΉ */
/* V0.954 */
/*   EA^CĐ@\ */
/*     wavĐAvinternalw肷邱ƂőΉ */
/*   E~LVOʂ16bits𒴂ꍇ̑Ώ */
/*     bISHRT_MAX/SHRT_MINɊۂ߂(t@Co/A^C) */
/*   Edefault.mx0΁A旧ēǂݍݐݒɗp */
/*     dꍇ̓R}hCwMX0t@C̒`D */
/*   Emx0[PF LightMode]Ōyʓ */
/*     oߎԕ\ȂA60tps10tpsɈ */
/*     MCMX1.exewłȂ */
/* V0.955 */
/*   EusageC */
/*   EׂʂȃWbNr*/
/*   E#JumpStartݒ肳Ăꍇ̌oߎԕ\C */
/*   EMX0t@Cɂ#hogehogeMMLɂwF߂ */
/*   EĐ̑ǉ QL[ōĐI WL[Ő擪Đ */
/* V0.956 */
/*   EĐJnVDOWNlƊeǂݍ݃t@C\ */
/*     VDownlMMLɂ#VolumeDownŎw肳 */
/*   EI4W[܂Ŏgp\(MMLRpC͑ΉĂȂ) */
/*     쌴Iɂ99mods܂ŖȂgp\(ʕ\4ȉz) */
/*   Egp */
/*     AvP[V̂ 2MBx */
/*     1W[ 3MBx + PCM */
/*   EPPSgpł悤ɉC(IɎgp) */
/*   Eyʓw肪ȂꍇPPS/P86/PPZ̈ꎞԂLɂ */
/* V0.96a */
/*   EftHgMX0`t@CPMDMX0.mx0ɕύX */
/*     Ȃꍇdefault.mx0ǂ݂ɂ */
/*   EI[o[t[\ǉ ĐԑтOFяIOF */
/*     200%(2ch)MAXƂƂɒ */

/* ʂȂႢȂ */
/*   EPPZH */
/*   Etf[^̏IFKv邩H */
/*   EϐPMDǂށMC.exeǂޕŌȂ or MCMX1.exefollow */
/*   E.MXC`ɑΉformat݌v or LZxpH (ZIPformatŊ댯) */
