#ifndef PMDMX_H
/**********************************************************************/
/* PMDMX0.h   multimodule-P.M.D. for commandline by JUD at 2007/11/30 */
/**********************************************************************/
#include "PMDWinImort.h"

/*--------------------------------------------------------------------*/
/* constants */
#define DN_MAX_LOADPMDWIN 4
#define DN_MAX_PXIDIRS 64
#define DN_DEF_OUTPUTLEN 300 /* #RecordLenw肳Ȃꍇ̍Đ */
#define DN_DXBUFFERS 8 /* obt@̒i */
#define DN_SAMPLERATE 44100 /* 44kHzŒ ȊÕeXgȂǂĂȂ */
#define DN_MIXUNITSLIGHT 4410 /* MixBufferSizeyʔ 1/10seconds */
#define DN_MIXUNITSAMPLE 735 /* MixBufferSize 1/60seconds */
//#define DN_MIXUNITSAMPLE 2940 /* MixBufferSize 1/15seconds */
//#define DN_MIXUNITSAMPLE 441 /* MixBufferSize 1/100seconds */
#define DN_OVERFLOWREFRESH 6 /* overflow\s[Nz[hێ(t[) */
/* 1 : DN_SAMPLERATE  DN_MIXUNITSAMPLE ̐{ł邱 */
/* 2 : WOM_DONEobt@ɏ܂20`40msecxv邽߁A */
/*             ȉ T 0.1(seconds)ȏۂ悤Ɉێ邱 */
/*             T = (DN_DXBUFFERS-1)*DN_MIXUNITSAMPLE/DN_SAMPLERATE */

#define D_ON 1
#define D_OFF 0

#define D_CONSOLE_REWIND 1
#define D_CONSOLE_TERMINATE 2

#define DS_EXT_MZ ".mz"
#define DS_EXT_MX0 ".mx0"
#define DS_EXT_OUT ".wav"

/* MX0 */
#define DS_DVALUE_INTERNALPLAYER "internal"
#define DS_DVALUE_LIGHTMODE "LightMode"
#define DS_DNAME_PXIPATH "PP"
#define DS_DNAME_QUICKSTART "QS"
#define DS_DNAME_JUMPSTART "JS"
#define DS_DNAME_RECORDLEN "RL"
#define DS_DNAME_WAVEFILENAME "WF"
#define DS_DNAME_PLAYERNAME "WP"
#define DS_DNAME_PERFORMANCE "PF"
/* DEFAULT.MX0p (ʏMX0łg邪) */
#define DS_DSNAME_QUICKSTART "#QuickStart"
#define DS_DSNAME_PLAYERNAME "#WavePlayer"
#define DS_DSNAME_WAVEFILENAME "#WaveFile"
#define DS_DSNAME_JUMPSTART "#JumpStart"
#define DS_DSNAME_RECORDLEN "#RecordLen"
#define DS_DSNAME_RHYTHMDIR "#RhythmDir"
#define DS_DSNAME_PXIPATH "#PCMDir"
#define DS_DSNAME_PERFORMANCE "#Performance"

#define DS_DEFAULTMX0_DEF "default.mx0"
#define DS_DEFAULTMX0_PMDMX0 "PMDMX0.mx0"
#define DS_PMDWINDLLNAME "PMDWin.dll"
#define DS_MYNAME "PMDMX0.exe"

/* error messages ɒ`ĂȂ̂PMDMX0ŔȂ */
#define DS_ERR_OPEN_MUSIC_FILE  "E[MX0] Could'nt open [%s].\n"
#define DS_ERR_WRONG_MUSIC_FILE "E[MX0] [%s] was not PMD-Format.\n"
#define DS_ERR_OPEN_PPC_FILE    "E[MX0] Could'nt open PPC, [%s].\n"
#define DS_ERR_OPEN_P86_FILE    "E[MX0] Could'nt open P86, [%s].\n"
#define DS_ERR_OPEN_PPS_FILE    "E[MX0] Could'nt open PPS, [%s].\n"
#define DS_ERR_OPEN_PPZ1_FILE   "E[MX0] Could'nt open PPZ1, [%s].\n"
#define DS_ERR_OPEN_PPZ2_FILE   "E[MX0] Could'nt open PPZ2, [%s].\n"
#define DS_ERR_WRONG_PPC_FILE   "E[MX0] [%s] was not PPC/PVI.\n"
#define DS_ERR_WRONG_P86_FILE   "E[MX0] [%s] was not P86.\n"
#define DS_ERR_WRONG_PPS_FILE   "E[MX0] [%s] was not PPS.\n"
#define DS_ERR_WRONG_PPZ1_FILE  "E[MX0] [%s] was not PVI/PZI(1).\n"
#define DS_ERR_WRONG_PPZ2_FILE  "E[MX0] [%s] was not PVI/PZI(2).\n"
#define DS_ERR_OUT_OF_MEMORY    "E[MX0] Could'nt allocation memories.\n"
#define DS_ERR_OTHER            "E[MX0] other error in PMDWin.\n"
#define DS_ERR_UNKNOWN          "E[MX0] unknown error.\n"

/* dll functions */
#define DS_PWF_GETV "getversion"
#define DS_PWF_GETIFV "getinterfaceversion"
#define DS_PWF_INIT "pmdwininit"
#define DS_PWF_SETPOS "setpos"
#define DS_PWF_MLOAD "music_load"
#define DS_PWF_MSTART "music_start"
#define DS_PWF_GETPCM "getpcmdata"
#define DS_PWF_SETPXI "setpcmdir"
#define DS_PWF_GETWORKOPEN "getopenwork"
#define DS_PWF_GETWORKPART "getpartwork"
#define DS_PWF_GETFNAMEMZ "getmusicfilename"
#define DS_PWF_GETFNAMEPCM "getpcmfilename"
#define DS_PWF_GETFNAMEPPS "getppsfilename"
#define DS_PWF_GETFNAMEPPZ "getppzfilename"
#define DS_PWF_SETPPSUSE "setppsuse"
#define DS_PWF_SETPPSIP "setppsinterpolation"
#define DS_PWF_SETP86IP "setp86interpolation"
#define DS_PWF_SETPPZIP "setppzinterpolation"

/*--------------------------------------------------------------------*/
/* structure */
/* PCMȗo͗pwb_ Ot@C̓ǂݎɂ͎gp֎~! */
/* MSRIFFAfmt`Nfact`NƎ */
typedef struct _t_combinewhead{
	char c_ftype[4];	/* "RIFF" */
	int i_size;			/* filesize */
	char c_rtype[4];	/* "WAVE" */
	char c_fctype[4];	/* chunktype "fmt " */
	int i_fcsize;		/* chunksize 16 */
	short fID;			/* format-id 1:PCM */
	short ch;			/* channel 1 or 2 */
	long hz;			/* sample rate */
	long bps;			/* BYTES/sec, = hz * blocksize */
	short blocksize;	/* BYTES, = bitrate/8 * ch */
	short bitrate;		/* BITS, 8 or 16 */
	char c_dctype[4];	/* chunktype "data" */
	int i_dcsize;		/* chunksize ? */
}T_COMBINEWAVEH;

/*--------------------------------------------------------------------*/
/* macros */

/* ėp GNX|[g֐Ăяo}N */
#define DFUNC(mod,fname) GetProcAddress(gx_pwdll[mod],fname)

typedef void (CALLBACK* XF_V_SP_I)(short *,int); /* getpcm */
typedef void (CALLBACK* XF_V_B)(bool);

/*====================================================================*/
/* classes */

/* /̓G[check/t@Ccheck */
class VARG{
private:
	char *mxname;
	int fMZ(char *cp_in);
	int fMX(char *cp_in);
	int pxicount; /* PCMfBNg`̐ */
	char vpxipath[DN_MAX_PXIDIRS+1][_MAX_PATH];
public:
	int lightmode; /* D_ON:yʓ */
	int maxunitsample; /* MixBufferSize(steps) */
	int jumpstart; /* seconds */
	int outputlen; /* seconds */
	int quickstart; /* twL */
	int modcount; /* MX0猈肵ǂݍނׂW[ */
	int bufsize; /* modmixobt@TCY(bytes) */
	int tps; /* b̍XV */
	char dllname[DN_MAX_LOADPMDWIN][_MAX_PATH];
	char mzname[DN_MAX_LOADPMDWIN][_MAX_PATH]; /* from MX0 */
	char wavd[DN_MAX_LOADPMDWIN][_MAX_PATH]; /* from MX0 */
	char outwavename[_MAX_PATH]; /* from MX0 */
	char exepath[_MAX_PATH];
	char datpath[_MAX_PATH];
	char playerpath[_MAX_PATH]; /* from MX0 */
	char *pxipath[DN_MAX_PXIDIRS+1]; /* from MX0 */
	char defMX0path[_MAX_PATH]; /* default.mx0݂̍菈 */
	XF_V_B fPPSUSE[DN_MAX_LOADPMDWIN]; /* PPSgp */
	XF_V_B fPPSIP[DN_MAX_LOADPMDWIN]; /* ꎞ */
	XF_V_B fP86IP[DN_MAX_LOADPMDWIN];
	XF_V_B fPPZIP[DN_MAX_LOADPMDWIN];
	long oftotal; /* I[o[t[ */
	/* ȉrealtimep */
	HWAVEOUT hWave;
	XF_V_SP_I fGetPCM[DN_MAX_LOADPMDWIN]; /* getpcm */
	short *directBuf[DN_DXBUFFERS]; /* DirectX֓n߂̃obt@ */
	short *rModBuf[DN_MAX_LOADPMDWIN]; /* PMDWin.dllႤׂ̃obt@ */
	long *rMixBuf; /* ~LVOpobt@ */
	/* functions */
	VARG();
	~VARG();
	int loadArg(int argc, char **argv);
	int viewSettings();
	int switchLightMode();
};

/*--------------------------------------------------------------------*/
/* Đ/~LVO(PCMt@Co͎p) */
class VMIX{
private:
	typedef void (CALLBACK* XF_V_SP_I)(short *,int);
	XF_V_SP_I xf_v_sp_i[DN_MAX_LOADPMDWIN];
	short *modbuf[DN_MAX_LOADPMDWIN];
	long *mixbuf;
	int bufsize;
	int mixsteps;
public:
	short *outbuf; /* mixς݃obt@ */
	int mixunits; /* mixobt@̃Tv */
	VMIX();
	~VMIX();
	int mixStart();
	int mixPlay();
};

/*--------------------------------------------------------------------*/
/* PCMt@Co */
class OUTPCM{
private:
	int i_outfile;
public:
	OUTPCM(char *,int);
	~OUTPCM();
	int outWave(short *,int);
};

/*--------------------------------------------------------------------*/
/* [Nf[^擾/\(S/񊄂荞) */
class VWORK{
private:
	typedef OPEN_WORK *(CALLBACK* XF_T1_V)(void);
	XF_T1_V f_gwo[DN_MAX_LOADPMDWIN];
	typedef QQ *(CALLBACK* XF_T2_I)(int);
	XF_T2_I f_gwp[DN_MAX_LOADPMDWIN];
	typedef char *(CALLBACK* XF_CP_CP)(char *);
	typedef char *(CALLBACK* XF_CP_CP_I)(char *,int);
	XF_CP_CP f_gfm[DN_MAX_LOADPMDWIN]; /* MZt@C擾֐ */
	XF_CP_CP f_gfp[DN_MAX_LOADPMDWIN]; /* P86/PPCt@C擾֐ */
	XF_CP_CP f_gfs[DN_MAX_LOADPMDWIN]; /* PPSt@C擾֐ */
	XF_CP_CP_I f_gfz[DN_MAX_LOADPMDWIN]; /* PPZt@C擾֐ */
	OPEN_WORK *tps_wo[DN_MAX_LOADPMDWIN];
	QQ *tps_wp[DN_MAX_LOADPMDWIN];
	char cs_lvh[1024], cs_lvf[1024], cs_lvs[1024], cs_lvp[1024], cs_lvz[1024];
	char cs_fnm[1024], cs_fnp[1024], cs_fns[1024], cs_fnz1[1024],cs_fnz2[1024];
	char *getLocalNameByFullName(char *,int);
	int titlelen;
public:
	VWORK();
	~VWORK();
	int viewWork(int);
};

/*--------------------------------------------------------------------*/
/* eLXgǂݎ/f[^o */
class READTEXT{
private:
	char *buf; /* ǂݍ񂾃f[^ DIVIDETOKEN()ōא؂ɂ */
	char *curline;
	char *getNextLine(char *);
public:
	char *data;
	int size;
	int status;
	int linecount;
	char *name; /* DIVIDETOKENŒoꂽ1J */
	char *value; /* DIVIDETOKENŒoꂽ2J */
	READTEXT(char *);
	~READTEXT();
	int DIVIDETOKEN(); /* ؂NULLȂ1sǂݐi߂ */
};

#endif
#define PMDMX_H
